% Example-39: Resolving Conflict with colo
% t1 and t2 are in conflict. t1 has 90% chance, whereas t2 has 10%
% Reggie.davidrajuh@uis.no  (c) 15 Nov 2017

function [fire, transition] = COMMON_PRE (transition)
% function [fire, transition] = COMMON_PRE (transition)

tname = transition.name;
switch tname
    case 'tS'
        random_num = rand; % 0 to 1
        %%%%   t1 has 90% chance, whereas t2 has only 10%
        if and(ge(random_num,0), lt(random_num,0.9))
            color = 't1'; % t1 can fire
        else
            color = 't2'; % t2 can fire
        end
        transition.new_color = color;
        fire = 1; % always fire tE as it is not in conflict
        
    case 't1'
        % From pS, t1 takes only the token with color 't1' 
        tokID = tokenAnyColor('pS', 1, {'t1'}); %  select token with color 't1'
        fire = tokID;
        
    case 't2'
        % From pS, t2 takes only the token with color 't2'
        tokID = tokenAnyColor('pS', 1, {'t2'}); %  select token with color 't2'
        fire = tokID;

    otherwise
        disp('Unknown method.')
end
