% Example-46: Token selection based on time 
% Reggie.davidrajuh@uis.no  (c) 15 Nov 2017

function [fire, transition] = COMMON_PRE (transition)

tname = transition.name;

% just let it fire, if the enabled trans is tStart or tDelay
if ismember(tname, {'tStart', 'tDelay'})
    fire = 1; return
end

% the following transitions select only three tokens based on time
if ismember(tname, {'tEarly', 'tIntv_E', 'tIntv_L', 'tLate'})
    tx = timesfired(tname); % how many times trans has already fired
    % trans can fire only three times
    if eq(tx, 3), fire = 0; return, end
    
    switch tname
        case 'tEarly'   % picks Earliest token
            tokID1 = tokenArrivedEarly('pQueue', 1);
        case 'tIntv_E'  % picks token from early time period
            tokID1 = tokenArrivedBetween('pQueue', 1, 10, 20);
        case 'tIntv_L'  % picks token from late time period
            tokID1 = tokenArrivedBetween('pQueue', 1, 80, 90);
        case 'tLate'   % picks latest token
            tokID1 = tokenArrivedLate('pQueue', 1);
        otherwise
            error('Not possible.')
    end % switch tname        
    
    transition.selected_tokens = tokID1;
    token_creation_time = get_tokCT('pQueue', tokID1);
    transition.new_color = num2str(token_creation_time);
    fire = tokID1;
end