% Example-48: Solving Cigerette Smokers' Problem
%   Solution based on "Colored Petri Net" 
% Reggie.davidrajuh@uis.no  (c) 15 Nov 2017

function [fire, transition] = COMMON_PRE (transition)

switch transition.name,
    case {'tSelect', 'tTBStop', 'tWPStop', 'tMAStop'}
        % tSelect has its own pre-processor
        % do nothing for 'tSelect', 'tTBStop', 'tWPStop', 'tMAStop'
        tokIDs = 1; 
        
    case 'tTBStart'
        % tTBStart should select tokens with color: WP and MA
        tokIDs = tokenWOAnyColor('pReady',2, {'TB'});
        
    case 'tWPStart'
        % tWPStart should select tokens with color: TB and MA
        tokIDs = tokenEXColor('pReady',2, {'TB', 'MA'});
        
    case 'tMAStart'
        % tMAStart should select tokens with color: TB and WP
        tokIDs = tokenAllColor('pReady',2, {'TB', 'WP'});
        
    otherwise
        error('what is this transition? .....');
end

transition.selected_tokens = tokIDs;
fire = all(tokIDs);
