% Example-48: Solving Cigerette Smokers' Problem
%   Solution based on "Colored Petri Net" 
% Reggie.davidrajuh@uis.no  (c) 15 Nov 2017

function [fire, transition] = tSelect_pre(transition)
global global_info

supply = global_info.SUPPLY; % strict smoking sequence
if isempty (supply)
    global_info.STOP_SIMULATION = 1; 
    fire = 0; return
end

% time to supply new materials
smoker = supply{1}; % who is the smoker  (smoker with 'TB', 'WP', or 'MA')
switch smoker % which smoker is chosen 
    case 'TB' % smoker with tobacco is choosen 
        supply_materials = {'WP', 'MA'}; % supply wrapping paper & matches
    case 'WP' % smoker with wrapping paper is choosen 
        supply_materials = {'TB', 'MA'}; % supply tobacco & matches        
    case 'MA' % smoker with matches is choosen 
        supply_materials = {'TB', 'WP'}; % supply tobacco & wrapping paper
    otherwise
        error('not possible');
end

% add the supply materials as colors
transition.new_color = supply_materials;  
transition.override = 1; % no color inheritence  
fire = 1; 

% reduce the smoking sequence by one
supply = supply(2:end); % crop smoker 
global_info.SUPPLY = supply; % the shortened smoking sequence
