% Example-49: Fibonacci number generation
%   Solution based on "Colored Petri Net" 
% Reggie.davidrajuh@uis.no  (c) 15 Nov 2017
%
% Pre-processor for tFibo: tFibo_pre.m
% tFibo a "cold start" transition. It always take the colors
%   of the two latest tokens in pFibo. From these two colors, 
%   a new Fibonacci number is made, and put as the color
%   of the token depositied into pFibo 


function [fire, transition] = tFibo_pre(transition)
global global_info

[set_of_tokIDs, nr_token_av] = tokenArrivedLate('pFibo', 2);   
if ne(nr_token_av, 2) % pFibo doesnt have 2 tokens yet
    fire = 0; return
end
 
tokID1 = set_of_tokIDs(1);  % get tokID of the latest token in pFibo
tokID2 = set_of_tokIDs(2);  % tokID of the second latest token in pFibo
color_set1 = get_color('pFibo', tokID1); % colors of the leatest token 
color_set2 = get_color('pFibo', tokID2); % colors of second leatest token
color1 = color_set1{1};	 % extract textstring from color set
color2 = color_set2{1};  % extract textstring from color set
 
fibo_num1 = str2num(color1); % convert textstring into number
fibo_num2 = str2num(color2); % convert textstring into number
new_fibo = int2str(fibo_num1 + fibo_num2); % make the new number

transition.new_color = new_fibo;
transition.override = 1;
transition.selected_tokens = [tokID1 tokID2];
fire = 1;

% already produced 5 fibonacci number? Then, stop
global_info.COUNTER = global_info.COUNTER + 1;
if gt(global_info.COUNTER, 5), global_info.STOP_SIMULATION = 1; end
